﻿using Connection;
using Connection.Class;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading;
using System.Windows.Forms;
using WBP_Office.Class;

namespace WBP_Office_API_Demo_Customer {

    public partial class Form1 : Form {

        public Form1() {
            InitializeComponent();
            System.Reflection.Assembly assembly = System.Reflection.Assembly.GetExecutingAssembly();
            var WBP_OfficeInfo = System.Reflection.Assembly.GetAssembly(typeof(WBP_Office.WBP_Office)).GetName();
            Text = $"{assembly.GetName().Name}  v{assembly.GetName().Version}           {WBP_OfficeInfo.Name}  v{WBP_OfficeInfo.Version}";
            comboBox4.SelectedIndex = 1;
            comboBox5.SelectedIndex = 0;
            comboBox6.SelectedIndex = 1;
            comboBox7.SelectedIndex = 1;
            comboBox8.SelectedIndex = 1;
            comboBox9.SelectedIndex = 0;
            comboBox10.SelectedIndex = 1;

            comboBox11.SelectedIndex = 1;
            comboBox12.SelectedIndex = 1;
            comboBox13.SelectedIndex = 0;
            comboBox14.SelectedIndex = 1;
            comboBox15.SelectedIndex = 1;
            comboBox16.SelectedIndex = 0;
            comboBox17.SelectedIndex = 0;
            comboBox18.SelectedIndex = 1;
            comboBox19.SelectedIndex = 0;
            comboBox20.SelectedIndex = 0;
        }

        private readonly Form_Chart form_Chart = new Form_Chart();
        private static WBP_Office.WBP_Office office;

        private void Form1_Load(object sender, EventArgs e) {
            comboBox1.SelectedIndex = 0;
            comboBox3.SelectedIndex = 1;
        }

        private void Office_OnReceived(Command command) {
            StringBuilder sb = new StringBuilder();
            switch (command.CMD) {
                case (byte)WBP_Office.Enum.Command.StartRemoteMeasurement:
                    richTextBox1.BeginInvoke((MethodInvoker)delegate {
                        sb.Append(richTextBox1.Text);
                        richTextBox1.Focus();
                        sb.Append(Environment.NewLine);
                        sb.Append("Start Remote Measurement,DataFormat is ").Append(((WBP_Office.Enum.DataFormat)command.Data).ToString());
                        richTextBox1.Text = sb.ToString();
                    });
                    break;

                case (byte)WBP_Office.Enum.Command.StopRemoteMeasurement:
                    richTextBox1.BeginInvoke((MethodInvoker)delegate {
                        sb.Append(richTextBox1.Text);
                        sb.Append(Environment.NewLine);
                        sb.Append("Stop Remote Measurement");
                        richTextBox1.Text = sb.ToString();
                    });
                    break;

                case (byte)WBP_Office.Enum.Command.RemoteStatus:
                    richTextBox1.BeginInvoke((MethodInvoker)delegate {
                        sb.Append(richTextBox1.Text);
                        sb.Append(Environment.NewLine);
                        sb.Append("call back RemoteStatus");
                        GlobalFunction.PrintAllProperties(command, ref sb, append: true);
                        richTextBox1.Text = sb.ToString();
                    });
                    break;

                case (byte)WBP_Office.Enum.Command.MeasurementResults:
                    richTextBox1.BeginInvoke((MethodInvoker)delegate {
                        sb.Append(richTextBox1.Text);
                        sb.Append(Environment.NewLine);
                        sb.Append("call back MeasurementResults");
                        GlobalFunction.PrintAllProperties(command, ref sb, append: true);
                        richTextBox1.Text = sb.ToString();
                    });
                    break;

                case (byte)WBP_Office.Enum.Command.dataRead:
                    richTextBox1.BeginInvoke((MethodInvoker)delegate {
                        Data data = (Data)command.Data;
                        GlobalFunction.PrintAllProperties(command, ref sb, append: true);
                        form_Chart.chart1.Series[0].Points.Clear();
                        form_Chart.chart2.Series[0].Points.Clear();
                        form_Chart.chart1.Series[0].Points.DataBindY(data.CBPData);
                        form_Chart.chart2.Series[0].Points.DataBindY(data.CalCBP);
                        richTextBox1.Text = sb.ToString();
                    });
                    break;
            }
        }

        private void Office_OnDisConnected() {
            try {
                Label_DevicePath.Invoke((MethodInvoker)delegate {
                    Label_DevicePath.Text = "";
                });
                button_Send.Invoke((MethodInvoker)delegate {
                    button_Send.Enabled = false;
                });
            } catch { }
            richTextBox1.BeginInvoke((MethodInvoker)delegate {
                richTextBox1.Text = richTextBox1.Text+"\n WBP Office is disconnected!";
            });
        }

        private void Office_OnConnected() {
            Label_DevicePath.Invoke((MethodInvoker)delegate {
                try {
                    Label_DevicePath.Text = office.DevicePath;
                } catch { }
            });
            button_Send.Invoke((MethodInvoker)delegate {
                button_Send.Enabled = true;
            });
            richTextBox1.BeginInvoke((MethodInvoker)delegate {
                richTextBox1.Text = "WBP Office is connected!";
            });
        }

        private void button_Send_Click(object sender, EventArgs e) {
            (bool Success, Command Command) callback;
            StringBuilder sb = new StringBuilder();
            switch (comboBox1.SelectedIndex) {
                case 0:
                    callback = office.SendMessage(WBP_Office.SendMessage.ToCommand.dataReadAll());
                    if (callback.Command.CMD == (byte)WBP_Office.Enum.Command.NACK) {
                        richTextBox1.Text = "NACK";
                        return;
                    } else if (!callback.Success) {
                        richTextBox1.Text = "No call back,Please try again";
                        return;
                    }
                    comboBox2.Items.Clear();
                    List<MData> listMData = (List<MData>)callback.Command.Data;
                    listMData.Where(x => x.Condition == WBP_Office.Enum.Condition.BPAndCBP).ToList().ForEach(x => comboBox2.Items.Add(x.Index));
                    try {
                        comboBox2.SelectedIndex = 0;
                    } catch { }
                    GlobalFunction.PrintAllProperties(callback, ref sb);
                    break;

                case 1:
                    if (comboBox2.SelectedIndex == -1) {
                        richTextBox1.Text = "Choose an ID";
                        return;
                    }
                    richTextBox1.Clear();
                    callback = office.SendMessage(WBP_Office.SendMessage.ToCommand.dataRead((int)comboBox2.SelectedItem, (WBP_Office.Enum.DataFormat)(comboBox3.SelectedIndex == 2 ? 3 : comboBox3.SelectedIndex)));
                    if (callback.Command.CMD == (byte)WBP_Office.Enum.Command.NACK) {
                        richTextBox1.Text = "NACK";
                        return;
                    } else if (!callback.Success) {
                        richTextBox1.Text = "No call back,Please try again";
                        return;
                    }
                    /*
                     *Because Office_OnReceived has print, is is not need here.
                    Data data = (Data)callback.Data;
                    PrintAllProperties(data);
                    */
                    break;

                case 2:
                    callback = office.SendMessage(WBP_Office.SendMessage.ToCommand.dataClear());
                    if (callback.Command.CMD == (byte)WBP_Office.Enum.Command.NACK) {
                        richTextBox1.Text = "NACK";
                        return;
                    } else if (!callback.Success) {
                        richTextBox1.Text = "No call back,Please try again";
                        return;
                    }
                    sb.Append("Memory have clear!");
                    break;

                case 3:
                    callback = office.SendMessage(WBP_Office.SendMessage.ToCommand.userInfoRead());
                    if (callback.Command.CMD == (byte)WBP_Office.Enum.Command.NACK) {
                        richTextBox1.Text = "NACK";
                        return;
                    } else if (!callback.Success) {
                        richTextBox1.Text = "No call back,Please try again";
                        return;
                    }
                    UserInfo userInfo = (UserInfo)callback.Command.Data;
                    sb.AppendFormat("UserID:{0}", userInfo.UserID).AppendLine();
                    textBox_NewID.Text = userInfo.UserID;
                    sb.AppendFormat("Protocal ID:{0}", userInfo.ProtocolID).AppendLine();
                    sb.AppendFormat("Max memory:{0}", userInfo.MaxMemory).AppendLine();
                    sb.AppendFormat("IHB:{0}", userInfo.IHB).AppendLine();
                    sb.AppendFormat("Firmware version:{0}", userInfo.FMVersion).AppendLine();
                    sb.AppendFormat("Firmware Date", userInfo.FMDate.ToString("yyyy-MM-dd")).AppendLine();
                    sb.AppendFormat("CBP:{0}", userInfo.CBP).AppendLine();
                    sb.AppendFormat("Voltage:{0} V", userInfo.BatteryVoltage).AppendLine();
                    sb.AppendFormat("arrhythmiaDisplay:{0}", userInfo.arrhythmiaDisplay.ToString()).AppendLine();
                    sb.AppendFormat("AFIB:{0}", userInfo.Afib).AppendLine();
                    richTextBox1.Text = sb.ToString();
                    break;

                case 4:
                    callback = office.SendMessage(WBP_Office.SendMessage.ToCommand.userIDWrite(textBox_NewID.Text));
                    if (callback.Command.CMD == (byte)WBP_Office.Enum.Command.NACK) {
                        richTextBox1.Text = "NACK";
                        return;
                    } else if (!callback.Success) {
                        richTextBox1.Text = "No call back,Please try again";
                        return;
                    }
                    sb.Append("New ID have writed");
                    break;

                case 5:
                    callback = office.SendMessage(WBP_Office.SendMessage.ToCommand.settingRead_BPM());
                    if (callback.Command.CMD == (byte)WBP_Office.Enum.Command.NACK) {
                        richTextBox1.Text = "NACK";
                        return;
                    } else if (!callback.Success) {
                        richTextBox1.Text = "No call back,Please try again";
                        return;
                    }
                    Setting_BPM setting_BPM = (Setting_BPM)callback.Command.Data;
                    textBox1.Text = setting_BPM.HI_infPressure.ToString();
                    textBox2.Text = setting_BPM.AUS_HI_infPressure.ToString();
                    textBox3.Text = setting_BPM.IntervalTime.ToString();
                    textBox4.Text = setting_BPM.AutoMeasureNumber.ToString();
                    textBox5.Text = setting_BPM.RestTime.ToString();
                    comboBox4.SelectedItem = setting_BPM.SW_AFib.ToString();
                    comboBox5.SelectedItem = setting_BPM.SW_AMPM.ToString();
                    comboBox6.SelectedItem = setting_BPM.SW_AUS_Hide.ToString();
                    comboBox7.SelectedItem = setting_BPM.SW_AUTO_hide.ToString();
                    comboBox8.SelectedItem = setting_BPM.SW_CBP.ToString();
                    comboBox9.SelectedItem = setting_BPM.SW_Kpa.ToString();
                    comboBox10.SelectedItem = setting_BPM.SW_SEL_silent.ToString();
                    comboBox19.SelectedItem = setting_BPM.SW_AVG_no_include_first.ToString();
                    GlobalFunction.PrintAllProperties(callback, ref sb);
                    break;

                case 6:
                    if (string.IsNullOrEmpty(textBox1.Text) || string.IsNullOrEmpty(textBox2.Text) || string.IsNullOrEmpty(textBox3.Text) || string.IsNullOrEmpty(textBox4.Text) || string.IsNullOrEmpty(textBox5.Text)) {
                        richTextBox1.Text = "Please fill Setting_BPM column";
                        break;
                    }
                    Setting_BPM Newsetting_BPM = new Setting_BPM {
                        HI_infPressure = int.Parse(textBox1.Text),
                        AUS_HI_infPressure = int.Parse(textBox2.Text),
                        IntervalTime = int.Parse(textBox3.Text),
                        AutoMeasureNumber = int.Parse(textBox4.Text),
                        RestTime = int.Parse(textBox5.Text),
                        SW_AFib = bool.Parse(comboBox4.SelectedItem.ToString()),
                        SW_AMPM = (WBP_Office.Enum.AMPM)Enum.Parse(typeof(WBP_Office.Enum.AMPM), comboBox5.SelectedItem.ToString()),
                        SW_AUS_Hide = bool.Parse(comboBox6.SelectedItem.ToString()),
                        SW_AUTO_hide = bool.Parse(comboBox7.SelectedItem.ToString()),
                        SW_CBP = bool.Parse(comboBox8.SelectedItem.ToString()),
                        SW_Kpa = (WBP_Office.Enum.PressureUnit)Enum.Parse(typeof(WBP_Office.Enum.PressureUnit), comboBox9.SelectedItem.ToString()),
                        SW_SEL_silent = bool.Parse(comboBox10.SelectedItem.ToString()),
                        SW_AVG_no_include_first = bool.Parse(comboBox19.SelectedItem.ToString())
                    };
                    callback = office.SendMessage(WBP_Office.SendMessage.ToCommand.settingWrite_BPM(Newsetting_BPM));
                    if (callback.Command.CMD == (byte)WBP_Office.Enum.Command.NACK) {
                        richTextBox1.Text = "NACK";
                        return;
                    } else if (!callback.Success) {
                        richTextBox1.Text = "No call back,Please try again";
                        return;
                    }
                    sb.Append("Write Success!");

                    break;

                case 7:
                    callback = office.SendMessage(WBP_Office.SendMessage.ToCommand.deviceIDRead());
                    if (callback.Command.CMD == (byte)WBP_Office.Enum.Command.NACK) {
                        richTextBox1.Text = "NACK";
                        return;
                    } else if (!callback.Success) {
                        richTextBox1.Text = "No call back,Please try again";
                        return;
                    }
                    DeviceID_and_Info deviceID_And_Info = (DeviceID_and_Info)callback.Command.Data;
                    textBox_DeviceID.Text = deviceID_And_Info.ID;
                    comboBox20.SelectedIndex = deviceID_And_Info.ConnectType == WBP_Office.Enum.ConnectType.USBOnly ? 0 : 1;
                    GlobalFunction.PrintAllProperties(callback, ref sb);
                    break;

                case 8:
                    callback = office.SendMessage(WBP_Office.SendMessage.ToCommand.timeRead());
                    if (callback.Command.CMD == (byte)WBP_Office.Enum.Command.NACK) {
                        richTextBox1.Text = "NACK";
                        return;
                    } else if (!callback.Success) {
                        richTextBox1.Text = "No call back,Please try again";
                        return;
                    }
                    DateTime dateTime = (DateTime)callback.Command.Data;
                    dateTimePicker1.Value = new DateTime(Math.Max(dateTime.Ticks, new DateTime(1753, 1, 1).Ticks));
                    richTextBox1.Text = "";
                    if (dateTime.Ticks < new DateTime(1753, 1, 1).Ticks)
                        sb.Append("Datetimepicker can't be set to before 1753/1/1 value,so show 1753/1/1").Append(Environment.NewLine);
                    sb.Append(dateTime.ToString("yyyy-MM-dd HH:mm:ss"));
                    break;

                case 9:
                    callback = office.SendMessage(WBP_Office.SendMessage.ToCommand.timeWrite(dateTimePicker1.Value));
                    if (callback.Command.CMD == (byte)WBP_Office.Enum.Command.NACK) {
                        richTextBox1.Text = "NACK";
                        return;
                    } else if (!callback.Success) {
                        richTextBox1.Text = "No call back,Please try again";
                        return;
                    }
                    sb.Append("Time had been sync");
                    break;

                case 10:
                    callback = office.SendMessage(WBP_Office.SendMessage.ToCommand.deviceSNRead());
                    if (callback.Command.CMD == (byte)WBP_Office.Enum.Command.NACK)
                    {
                        richTextBox1.Text = "NACK";
                        return;
                    }
                    else if (!callback.Success)
                    {
                        richTextBox1.Text = "No call back,Please try again";
                        return;
                    }
                    String SN = (String)callback.Command.Data;
                    sb.Append(SN+"\n");
                    break;

                case 11:
                    callback = office.SendMessage(WBP_Office.SendMessage.ToCommand.settingRead_BPM_Function());
                    if (callback.Command.CMD == (byte)WBP_Office.Enum.Command.NACK) {
                        richTextBox1.Text = "NACK";
                        return;
                    } else if (!callback.Success) {
                        richTextBox1.Text = "No call back,Please try again";
                        return;
                    }
                    Setting_BPM_Function setting_BPM_Function = (Setting_BPM_Function)callback.Command.Data;
                    comboBox11.SelectedItem = setting_BPM_Function.Fun_SEL_AFib.ToString();
                    comboBox12.SelectedItem = setting_BPM_Function.Fun_SEL_AMPM.ToString();
                    comboBox13.SelectedItem = setting_BPM_Function.Fun_SEL_AutoTest.ToString();
                    comboBox14.SelectedItem = setting_BPM_Function.Fun_SEL_Bluetooth.ToString();
                    comboBox15.SelectedItem = setting_BPM_Function.Fun_SEL_CBP_algo.ToString();
                    comboBox16.SelectedItem = setting_BPM_Function.Fun_SEL_CBP_CL.ToString();
                    comboBox17.SelectedItem = setting_BPM_Function.Fun_SEL_RS232.ToString();
                    comboBox18.SelectedItem = setting_BPM_Function.Fun_SEL_UnitKpa.ToString();
                    GlobalFunction.PrintAllProperties(callback, ref sb);
                    break;

                case 12:
                    callback = office.SendMessage(WBP_Office.SendMessage.ToCommand.bluetoothnameRead());
                    if (callback.Command.CMD == (byte)WBP_Office.Enum.Command.NACK) {
                        richTextBox1.Text = "NACK";
                        return;
                    } else if (!callback.Success) {
                        richTextBox1.Text = "No call back,Please try again";
                        return;
                    }
                    string s = (string)callback.Command.Data;
                    textBox_BTName.Text = s;
                    richTextBox1.Text = s;
                    break;

                case 13:
                    callback = office.SendMessage(WBP_Office.SendMessage.ToCommand.StartRemoteMeasurement((WBP_Office.Enum.DataFormat)(comboBox3.SelectedIndex == 2 ? 3 : comboBox3.SelectedIndex)));
                    if (callback.Command.CMD == (byte)WBP_Office.Enum.Command.NACK) {
                        richTextBox1.Text = "NACK";
                        return;
                    } else if (!callback.Success) {
                        richTextBox1.Text = "No call back,Please try again";
                        return;
                    }
                    sb.Clear();
                    break;

                case 14:
                    callback = office.SendMessage(WBP_Office.SendMessage.ToCommand.StopRemoteMeasurement());
                    if (callback.Command.CMD == (byte)WBP_Office.Enum.Command.NACK) {
                        richTextBox1.Text = "NACK";
                        return;
                    } else if (!callback.Success) {
                        richTextBox1.Text = "No call back,Please try again";
                        return;
                    }
                    break;



                case 15:
                    break;
            }
            richTextBox1.Text = sb.ToString();
        }

        private void button1_Click(object sender, EventArgs e) {
            form_Chart.Show();
        }

        private void DeviceIDCheck(object sender, KeyPressEventArgs e) {
            try {
                if (e.KeyChar != '\b')
                    Convert.ToInt32(e.KeyChar.ToString(), 16);
            } catch { e.Handled = true; }
        }

        private async void Button_BLE_Click(object sender, EventArgs e) {
            if (!Connection.GlobalFunction.WinRT_API_Support) {
                MessageBox.Show("Operating system requires Windows 10 1803 or higher!");
                return;
            }
            Form_BLE_Discover form_BLE_Discover = new Form_BLE_Discover();
            form_BLE_Discover.ShowDialog();
            switch (form_BLE_Discover.BLEAction) {
                case BLEAction.Connect:
                    office?.HID_Disconnect();
                    office = new WBP_Office.WBP_Office(textBox_key.Text, true);
                    office.OnDisConnected += Office_OnDisConnected;
                    office.OnReceived += Office_OnReceived;
                    office.OnReceivedRaw += Office_OnReceivedRaw;
                    var connectionResult = await office.ConnectWithBLE(form_BLE_Discover.BLE_ID);
                    if (connectionResult.ErrorMessage == "Device is unreachable (i.e. out of range or shutoff)") {
                        MessageBox.Show("Please check the connection or unpair BLE, both of PC and blood pressure monitor.");
                        Office_OnDisConnected();
                    }
                    if (office.Connected) {
                        var result = await Connection.PairingHelper.PairDeviceAsync(form_BLE_Discover.BLE_ID);
                        try {
                            await office.SendMessageAsync(WBP_Office.SendMessage.ToCommand.timeRead());
                        } catch {
                            MessageBox.Show("Please unpair BLE on blood pressure monitor.");
                            await Connection.PairingHelper.UnpairDeviceAsync(form_BLE_Discover.BLE_ID);
                            await office?.DisconnectWithBLE();
                        }
                        ThreadStart threadStart = new ThreadStart(() => Office_OnConnected());
                        Thread thread = new Thread(threadStart);
                        thread.Start();
                    }
                    break;

                case BLEAction.Disconnect:
                    if (office.ConnectionType == 1) {
                        office?.Dispose();
                        office = new WBP_Office.WBP_Office(textBox_key.Text);
                        office.OnConnected += Office_OnConnected;
                        office.OnDisConnected += Office_OnDisConnected;
                    }
                    break;

                case BLEAction.Pair:
                    await Connection.PairingHelper.PairDeviceAsync(form_BLE_Discover.BLE_ID);
                    break;

                case BLEAction.Unpair:
                    await Connection.PairingHelper.UnpairDeviceAsync(form_BLE_Discover.BLE_ID);
                    break;
            }
        }

        private void Button_CheckKey_Click(object sender, EventArgs e) {
            try {
                office = new WBP_Office.WBP_Office(textBox_key.Text);
                office.OnConnected += Office_OnConnected;
                office.OnDisConnected += Office_OnDisConnected;
                office.OnReceived += Office_OnReceived;
                office.OnReceivedRaw += Office_OnReceivedRaw;
                office.InitDeviceWatcher();
                button_BLE.Enabled = true;
                button_Send.Enabled = true;
                textBox_key.Enabled = false;
                (sender as Button).Enabled = false;
            } catch (Exception ee) {
                if (ee.Message == "Key Fail!") {
                    MessageBox.Show("Key Fail!");
                }
            }
        }
        protected List<byte> messageReceiced = new List<byte>();
        private void Office_OnReceivedRaw(byte[] EffectiveByte) {

            messageReceiced.AddRange(EffectiveByte);
            //if messageReceiced.Count >= (messageReceiced[3] + 4) means all raw data has been received
            while (messageReceiced.Count >= 4 && messageReceiced.Count >= (messageReceiced[3] + 4) 
                && messageReceiced[0] == 0x4d && messageReceiced[1] == 0x42) {

                byte[] buffer1 = new byte[messageReceiced[3] + 4];
                Array.Copy(messageReceiced.ToArray(), buffer1, messageReceiced[3] + 4);

                richTextBox1.BeginInvoke((MethodInvoker)delegate {
                    richTextBox1.Text += "\nRawData:";
                    richTextBox1.Text += ToHexString(buffer1);
                    richTextBox1.Text += "\n";
                });
                messageReceiced.RemoveRange(0, messageReceiced[3] + 4);
            }
        }

        public static string ToHexString(byte[] bytes) // 0xae00cf => "AE00CF "
{
            string hexString = string.Empty;
            if (bytes != null) {
                StringBuilder strB = new StringBuilder();
                for (int i = 0; i < bytes.Length; i++) {
                    strB.Append(bytes[i].ToString("X2"));
                    strB.Append(" ");
                }
                hexString = strB.ToString();
            }
            return hexString;
        }

        private void textBox_key_TextChanged(object sender, EventArgs e) {

        }
    }
}